/*
 * Copyright 1995, 1998 Perforce Software.  
 *
 * This file is part of WebKeeper, a perforce client apache module.
 *
 * License is hereby granted to use this software and distribute it
 * freely, as long as this copyright notice is retained and modifications
 * are clearly marked.
 *
 * ALL WARRANTIES ARE HEREBY DISCLAIMED.
 *
 * $Id: //guest/seiwald/webkeeper/mod_webkeep.h#3 $
 */

/*
 * webkeep.h - glue mod_webkeep.c to the Perforce api via webkeep.cc
 *
 * This header file is for inclusion by mod_webkeep.c when building
 * webkeeper into an Apache web server.
 */

typedef struct _WebKeepPrinter WebKeepPrinter;
typedef struct _WebKeepConnect WebKeepConnect;

/*
 * WebKeepConnect - pointers to configuration data stored by Apache
 */

struct _WebKeepConnect {

	char *port;	/* WebKeepPort - default $P4PORT, perforce:1666 */
	char *user;	/* WebKeepUser - default $P4USER, $USERNAME */
	char *pass;	/* WebKeepPasswd - no default */
	char *client;	/* WebKeepClient - default $P4CLIENT, hostname */

} ;

/*
 * WebKeepPrinter - callbacks to Apache code 
 */

struct _WebKeepPrinter {

	int status;
	void *closure;
	WebKeepConnect *p4;
	void (*data)(WebKeepPrinter *,int isBinary);
	void (*text)(WebKeepPrinter *,char *,int);
	void (*error)(WebKeepPrinter *,char *);

} ;

# ifdef CPLUSPLUS
extern "C" {
# endif

void webKeepPrint( 
	const char *path, 
	const char *user,
	const char *passwd,
	WebKeepPrinter *printer );

# ifdef CPLUSPLUS
}
# endif

